import { ViewBase } from '../../libappbase/viewbase';
import { UIWaitSOP } from '../../libappsop/objectsop';
import { OptimizerButtonContextMenuItem } from '../actionbarpages/abp.scenarioselection';
import { AppMP } from '../appmp';
import { FormOptimizerStrategies } from '../forms/form.optimizerstrategies';

/**
 * Scenarios > Optimizer Strategies view
 */
export class ViewOptimizerStrategies extends ViewBase implements UIWaitSOP {
  public readonly name = 'Optimizer strategies';
  public readonly viewPath = 'Top right > Optimizer > Optimizer Strategies';
  public readonly stepDescription = `Open right docked panel via ${this.viewPath}.`;
  public frmOptimizerStrategies = new FormOptimizerStrategies();

  public async switchTo(): Promise<void> {
    const appMP = AppMP.getInstance();
    await appMP.abpScenario.click(); // For tests that need click on action buttons (create,edit,delete,copy)
    // Optimizer strategies located at top right action bar
    await appMP.abpScenarioSelection.btnRunOptimizer.clickDropdownAndSelectMenu(OptimizerButtonContextMenuItem.OptimizerStrategies.Name);
    await this.waitUILoaded();
  }

  public async waitUILoaded(): Promise<void> {
    await this.frmOptimizerStrategies.waitUntilPresent();
  }
}
